#!/usr/bin/perl -w
#
# Schpati - Pre-Alpha of AndyChat v3.xx
#
# Started on Wednesday, 9th of February, 2000 around 11pm
#
# Build 0322 - 22nd of March, 2000
# - (12.13am) Changed IRC polls to test a theory
# - (12.48am) Restored IRC poll time
# -  ( ---- ) Fixed keyboard buffer scrollback
# -  (1.10am) Doubled line limit
# -  (1.17am) Moved /IRC JOIN to /JOIN
# -  ( ---- ) Made /J to /JOIN alias
# -  (2.38am) Tried to add up/down buffer support - failed
# -  (2.42am) Fixed up/down keyboard support
# -  (2.42am) Removed bogus keyboard arrow stuffz
# -  (2.44am) Fixed up/down keyboard count error
# -  (2.45am) Fixed up/down keyboard undefined var error
# -  (2.48am) Added "command not found" error
# -  (2.49am) Added "command not found" error - for IRC too
# -  (8.42pm) Once again porting SaveSpace bits
# -  (9.09pm) /NICK kinda implemented .. kinda
# -  (9.11pm) /QUOTE kinda implemented
#
# Build 0321 - 21st of March, 2000
# -  (1.00am) Continued work on stuffz
# -  (1.25am) Ported up-arrow back function thing incorrectly
# -  ( ---- ) Added DoIdleLoop
# -  ( ---- ) Added /me command (action).  Works for IRC.
# -  ( ---- ) Added /msg command (private message).  Works for IRC.
# -  ( ---- ) Added more IRC handlers
# -  (7.15pm) Tried to fix character bungling
# -  (8.08pm) Fixed character weirdness (backspace at beginning of line, ^_ stuffz)
# -  (8.18pm) Fixed bug thing
# - (10.10pm) Added port parameter to /irc connect
# - (10.56pm) Andrew can't count :)  /WHOIS = 6+1=7
# - (10.57pm) Andrew can't count :)  1 parameter = 1 parameter
# - (11.10pm) Made Build 0321 distribution
#
# Build 0217 - 17th of February, 2000
# -  (2.18pm) Fixed displaying of space after [xxx] room number if no topic
# -  (4.52pm) Porting more of end of code stuff
# -  (5.17pm) Porting more text entry nonsense
# -  (9.35pm) Began porting the basics of SaveSpace
#
# Build 0212 - 12th of February, 2000 (why do I bother with the date? :P)
# -  (1.08am) Resumed Work
# -  (1.xxam) Finished main sub (in a way)
# -  (1.56am) Finished Work for now
# -  (4.20pm) Integrated Language bits
#
# Build 0210 - 10th of February, 2000
# - (11.xxam) Continued stuffz
# -  (4.01pm) Fixed disappearing time bug
# -  (9.10pm) Started GetLLine
# - (10.25pm) Fixed yellow/magenta colour mistake
# - (10.30pm) GetLLine now properly recognises Backspace in XTerm and Console (?)
#
# Build 0209 - 9th of February, 2000
# - (11.xxpm) Initial Development
#
use Curses;
use Time::HiRes qw ( time alarm sleep );
use Term::ReadKey;
use Net::IRC;

do 'andy-ext.pl';
do 'curses2andy.pl';

do 'andy-txt.pl';

do 'a_lang.pl';
do 'a_common.pl';
do 'a_logo.pl';
do 'a_protocols.pl';

$kbuff = "";	# You can't understand how dodgy this is :(((
$Version = "3.00";
$Build = "0322";
ReadMode(4);

# SUBS GO HERE

sub GetLLine {
  my ($zz1, $zz2, $zz3) = @_;

  $j = wherey();
  $k = wherex();
  $ch = "";
  if ($zz1 ne "")
  {
    $i = length($zz1);
    $tempstr = $zz1;
    if (length($tempstr) > $zz2)
    {
      addstr(substr($tempstr, length($tempstr) - $zz2, $zz2)); refresh;
    }
    else
    {
      addstr($tempstr); refresh;
    }
  }
  else
  {
    $i = 0;
    $tempstr = "";
  }
  while ($ch ne chr(13))
  {
    while (not keypressed())
    {
      # if (networking())
      # {
      #   if ($messwaiting < 20)
      #   {
      #     $messwaiting++;
      #     UpdateGame(5);
      #     $mess[$messwaiting] = getpacket();
      #   }
      #   else
      #   {
      #     for ($t = 1; $t <= 19; $t++)
      #     {
      #       $mess[$t] = $mess[$t + 1];
      #     }
      #     $mess[20] = getpacket();
      #   }
      #   EatWaiting();
      # }
      # CheckTheMess();
      # NetworkRelinquishControlProbePollWhateverItsCalledInNetworkInterfaceToScanForStuffToDo();
      DoIdleLoop;
    }
    $ch = kbuf();
    if (ord($ch) eq 27)
    {
      if (keypressed() && $kbuff eq "[")
      {
        $ch = kbuf();
        if (keypressed() && $kbuff eq "A")
        {
          $ch = kbuf();
          $kbuff = $kbuff . chr(0) . chr(72);
          $ch = kbuf();
        }
        elsif (keypressed() && $kbuff eq "B")
        {
          $ch = kbuf();
          $kbuff = $kbuff . chr(0) . chr(80);
          $ch = kbuf();
        }
      }
      else
      {
# Lost characters
      }
    }
    if ($ch eq chr(127))
    {
      if (keypressed())
      {
        $ch = kbuf();
        if ($ch eq "?")
        {
          $kbuff = $kbuff . chr(8);
          $ch = kbuf();
        }
      }
    }
    if ((($ch eq chr(8)) || ($ch eq chr(127))) && ($i > 0))
    {
      $i--;
      if ($i eq 0)
      {
        $tempstr = "";
        $ch = chr(13);
      }
      else
      {
        $tempstr = substr($tempstr, 0, -1);
      }
      if ($i >= $zz2)
      {
        gotoxy($k, $j); addstr(substr($tempstr, $i - $zz2, $zz2)); refresh;
      }
      else
      {
        gotoxy(wherex() - 1, wherey()); addstr(" "); gotoxy(wherex() - 1, wherey()); refresh;
      }
    }
    elsif (ord($ch) eq 0)
    {
      if (keypressed())
      {
        $ch = kbuf();
        if (ord($ch) eq 72)
        {
          if ($bktype > 1 && $backtype[$bktype - 1] && $backtype[$bktype - 1] ne "")
          {
            $bktype--;
            $tempstr = $backtype[$bktype];
            $i = length($tempstr);
            gotoxy(1 + reallength($my{'name'}) + 2, $maxy - 2); textcolor($colour{'scrollback'});
            addstr(strpadd("", $maxx - 20 - reallength($my{'name'}), " "));
            gotoxy(1 + reallength($my{'name'}) + 2, $maxy - 2); 
            if (length($tempstr) > $zz2)
            {
              addstr(substr($tempstr, length($tempstr) - $zz2, $zz2)); refresh;
            }
            else
            {
              addstr($tempstr); refresh;
            }
          }
        }
        elsif (ord($ch) eq 80)
        {
          if ($bktype < 10)
          {
            $bktype++;
            $tempstr = $backtype[$bktype];
            $i = length($tempstr);
            gotoxy(1 + reallength($my{'name'}) + 2, $maxy - 2); textcolor($colour{'scrollback'});
            addstr(strpadd("", $maxx - 20 - reallength($my{'name'}), " "));
            gotoxy(1 + reallength($my{'name'}) + 2, $maxy - 2); 
            if (length($tempstr) > $zz2)
            {
              addstr(substr($tempstr, length($tempstr) - $zz2, $zz2)); refresh;
            }
            else
            {
              addstr($tempstr); refresh;
            }
          }
          elsif ($bktype eq 10)
          {
            addstr($maxy - 2, 1, strpadd("", $maxx - 20, " "));
            gotoxy(1, $maxy - 2);
            return "";
          }
        }
      }
    }
    elsif ((ord($ch) > 31) && ($i <= $zz3))
    {
      $tempstr = "$tempstr$ch";
      $i++;
      if ($i > $zz2)
      {
        gotoxy($k, $j);
        addstr(substr($tempstr, $i - $zz2, $zz2 - 1) . $ch); refresh;
      }
      else
      {
        addstr($ch); refresh;
      }
    }
  }
  return $tempstr;
}

sub DoIdleLoop {
  if ($ircconnections > 0)
  {
    $andychat_irc->do_one_loop();
  }
  # if (networking())
  # {
  #   if ($messwaiting < 20)
  #   {
  #     $messwaiting++;
  #     UpdateGame(5);
  #     getipx($mess[$messwaiting]);
  #   }
  #   else
  #   {
  #     for ($t = 1; $t <= 19; $t++)
  #     {
  #       $mess[$t] = $mess[$t + 1];
  #     }
  #     getipx($mess[20]);
  #   }
  #   gotoxy(1, $maxy - 1);
  # }
  # ChecktheMess();
  if (($playfile) && (time() - $pfi11 > 0.5))
  {
    if ($pfin < $pfis)
    {
      $pfi11 = time();
      $astr = $pfit[$pfin];
      goto afterinp;
    }
    else
    {
      $playfile = "";
      $astr = Lang(105);
      goto afterinp;
    }
  }
  if ($ltime ne qbTIME())
  {
    gotoxy($maxx - 21, 1); textcolor($colour{'time'});
    addstr(substr(qbTIME(), 0, 5)); $ltime = qbTIME();
    gotoxy(1, $maxy - 2); textcolor($colour{'typemsg'});
    refresh();
  }
  if ($ldate ne qbDATE())
  {
    gotoxy($maxx - 12, 1); textcolor($colour{'date'});
    addstr(substr(qbDATE(), 0, 2) . "/" . substr(qbDATE(), 3, 2) . "/" . substr(qbDATE(), -2, 2)); $ldate = qbDATE();
    gotoxy(1, $maxy - 2); textcolor($colour{'typemsg'});
    refresh();
  }
}

sub SaveSpace {
  if (uc(substr($ppp, 0, 10)) eq "/IRC JOIN ")
  {
    $ppp = "/JOIN " . substr($ppp, 10);
  }
  elsif (uc(substr($ppp, 0, 3)) eq "/J ")
  {
    $ppp = "/JOIN " . substr($ppp, 3);
  }
  elsif (uc(substr($ppp, 0, 5)) eq "/MSG ")
  {
    $ppp = "/P " . substr($ppp, 5);
  }

  if (uc(substr($ppp, 0, 5)) eq "/IRC ")
  {
    $ppp = ltrim(substr($ppp, 4));
    if (uc(substr($ppp, 0, 7)) eq "SERVER ")
    {
      $ppp = "CONNECT " . substr($ppp, 7);
    }

    if (uc(substr($ppp, 0, 8)) eq "CONNECT ")
    {
      $ppp = substr($ppp, 8);
      if (index($ppp, " ") > -1)
      {
        $ppp1 = substr($ppp, index($ppp, " ") + 1);
        $ppp = substr($ppp, 0, index($ppp, " "));
      }
      else
      {
        $ppp1 = 6667;
      }
      AddLine(Lang(24) . "`%Connecting to `7" . $ppp);
      $ircconnections++;
      $andychat_irc = new Net::IRC;
      $andychat_irc->timeout(0.01);
      $window[$thiswin]->{protocol} = 2;
      $window[$thiswin]->{control} = $andychat_irc->newconn(Nick => $my{'name'},
                                              Server => $ppp,
                                              Port => $ppp1,
                                              Ircname => 'AndyChat ' . $Version);
      $window[$thiswin]->{control}->add_global_handler(378, \&irc__on_motd);
      $window[$thiswin]->{control}->add_global_handler(377, \&irc__on_motd);
      $window[$thiswin]->{control}->add_global_handler(376, \&irc__on_connect);
      $window[$thiswin]->{control}->add_global_handler(375, \&irc__on_motd);
      $window[$thiswin]->{control}->add_global_handler(372, \&irc__on_motd);
      $window[$thiswin]->{control}->add_global_handler(353, \&irc__on_names);
      $window[$thiswin]->{control}->add_global_handler(255, \&irc__on_lusers);
      $window[$thiswin]->{control}->add_global_handler(254, \&irc__on_lusers);
      $window[$thiswin]->{control}->add_global_handler(253, \&irc__on_lusers);
      $window[$thiswin]->{control}->add_global_handler(252, \&irc__on_lusers);
      $window[$thiswin]->{control}->add_global_handler(251, \&irc__on_lusers);
      $window[$thiswin]->{control}->add_handler('join', \&irc__on_join);
      $window[$thiswin]->{control}->add_handler('quit', \&irc__on_quit);
      $window[$thiswin]->{control}->add_handler('nick', \&irc__on_nick);
      $window[$thiswin]->{control}->add_handler('part', \&irc__on_part);
      $window[$thiswin]->{control}->add_handler('msg', \&irc__on_msg);
      $window[$thiswin]->{control}->add_handler('whoisuser', \&irc__on_whoisuser);
      $window[$thiswin]->{control}->add_handler('whoisserver', \&irc__on_whoisserver);
      $window[$thiswin]->{control}->add_handler('whoisoperator', \&irc__on_whoisoperator);
      $window[$thiswin]->{control}->add_handler('whoischanop', \&irc__on_whoischanop);
      $window[$thiswin]->{control}->add_handler('whoischannels', \&irc__on_whoischannels);
      $window[$thiswin]->{control}->add_handler('whoisidle', \&irc__on_whoisidle);
      $window[$thiswin]->{control}->add_handler('endofwhois', \&irc__on_endofwhois);
      $window[$thiswin]->{control}->add_handler('notice', \&irc__on_notice);
      $window[$thiswin]->{control}->add_handler('public', \&irc__on_public);
      $window[$thiswin]->{control}->add_handler('caction', \&irc__on_caction);
      $window[$thiswin]->{control}->add_handler('topic', \&irc__on_topic);
      $window[$thiswin]->{control}->add_handler('cversion', \&irc__on_cversion);
      $window[$thiswin]->{sortusers} = 1;
    }
    else
    {
      AddLine("Command $ppp not found", Lang(16));
    }
  }
  elsif (uc(substr($ppp, 0, 5)) eq "/NICK")
  {
    if (uc($ppp) eq "/NICK")
    {
      if ($window[$whichwin]->{protocol} eq 2)
      {
# Early Implementation :)
#        irc__names($window[$thiswin]->{control}, $window[$thiswin]->{channel});
      }
    }
    else
    {
      $ppp = Strrrp($ppp);
      if (length($ppp) > 12)
      {
        AddLine(Lang(24), Lang(16));
      }
      if (FindUser($thiswin, 1, $ppp) > 0)
      {
        AddLine(Lang(17), Lang(16));
      }
      else
      {
        if ($window[$thiswin]->{protocol} eq 2)
        {
# Early Implementation :)
#          irc__nick($window[$thiswin]->{control}, $ppp);
        }
      }
    }
  }
  elsif (uc(substr($ppp, 0, 7)) eq "/QUOTE ")
  {
    $ppp = substr($ppp, 7);
    if ($window[$thiswin]->{protocol} eq 2)
    {
# Early Implementation :)
#      irc__raw($window[$thiswin]->{control}, $ppp);
    }
  }
  elsif (uc(substr($ppp, 0, 13)) eq "/REDRAWSCREEN")
  {
    DrawMainScreen("");
  }
  elsif (uc(substr($ppp, 0, 12)) eq "/REDRAWNICKS")
  {
    RedrawNicks;
  }
  elsif (uc(substr($ppp, 0, 4)) eq "/ME ")
  {
    if ($window[$thiswin]->{protocol} eq 2)
    {
      if ($window[$thiswin]->{channel} ne "")
      {
        irc__action($window[$thiswin]->{control}, $window[$thiswin]->{channel}, substr($ppp, 4));
        AddLine(substr($ppp, 4), "`8" . chr(ACS_S1) . " `%" . $my{'name'} . " `7");
      }
      else
      {
      }
    }
  }
  elsif (uc(substr($ppp, 0, 3)) eq "/P ")
  {
    $ppp = substr($ppp, 3);
    if (index($ppp, " ") > -1)
    {
      if ($window[$thiswin]->{protocol} eq 2)
      {
        irc__privmsg($window[$thiswin]->{control}, substr($ppp, 0, index($ppp, " ")), substr($ppp, index($ppp, " ") + 1));
        AddLine(substr($ppp, index($ppp, " ") + 1), "`8[`4msg`8(`@" . substr($ppp, 0, index($ppp, " ")) . "`8)] `7");
      }
    }
  }
  elsif (uc(substr($ppp, 0, 8)) eq "/NOTICE ")
  {
    $ppp = substr($ppp, 8);
    if (index($ppp, " ") > -1)
    {
      if ($window[$thiswin]->{protocol} eq 2)
      {
        irc__notice($window[$thiswin]->{control}, substr($ppp, 0, index($ppp, " ")), substr($ppp, index($ppp, " ") + 1));
        AddLine(substr($ppp, index($ppp, " ") + 1), "`8[`4notice`8(`@" . substr($ppp, 0, index($ppp, " ")) . "`8)] `7");
      }
    }
  }
  elsif (uc(substr($ppp, 0, 7)) eq "/WHOIS ")
  {
    $ppp = substr($ppp, 7);
    if ($window[$thiswin]->{protocol} eq 2)
    {
      irc__whois($window[$thiswin]->{control}, $ppp);
    }
  }
  elsif (uc(substr($ppp, 0, 6)) eq "/JOIN ")
  {
    if ($window[$thiswin]->{protocol} eq 2)
    {
      if (! $window[$thiswin]->{channel})
      {
        $window[$thiswin]->{control}->join(substr($ppp, 6));
        $window[$thiswin]->{channel} = substr($ppp, 6);
#        AddLine(Lang(24) . "`%Joining `7" . substr($ppp, 6));
      }
      else
      {
        AddLine("This window is already linked to a channel!", Lang(16));
      }
    }
  }
  else
  {
    AddLine("Command $ppp not found", Lang(16));
  }
}

# SUBS END HERE

# VAR HACKS START HERE

$carrnum = "001";

# VAR HACKS END HERE

print "\nAndyCHAT XXX $Version - Do Not Distribute! Unless at Aardy''s Network Games!\n";
print "Written by Andrew Macks (Andypoo) for Private and Network Games Use Only!\n";

#sleep 50;

$mainwin = initscr();
getmaxyx($mainwin, $maxy, $maxx);

start_color();

textcolor(15); textbackground(4);
addstr(0, 0, " AndyChat for IRC v$Version -=- Build " . $Build . " -=- (c) 1997 to 2000 Andypoo''s Software");
addstr(SPACEs($maxx - wherex()));
gotoxy(0, 1);
textbackground(0);
textcolor(15); addch(ACS_DIAMOND); textcolor(7); addstr(" Starting Engine ... "); refresh;
textcolor(10); addstr("Complete\n"); refresh;
$my{'invis'} = ""; $logging = ""; $addbuffer = ""; $locas = "";
textcolor(15); addch(ACS_DIAMOND); textcolor(7); addstr(" Reading Configuration File ... "); refresh;
ReadConfig();
textcolor(10); addstr("Complete\n"); refresh;
textcolor(15); addch(ACS_DIAMOND); textcolor(7); addstr(" Searching for IPX Packet Driver ... "); refresh;
textcolor(12); addstr("Fail"); textcolor(7); addstr(" because we don't use it anymore\n"); refresh;
textcolor(15); addch(ACS_DIAMOND); textcolor(7); addstr(" Opening Network Socket ... "); refresh;
textcolor(12); addstr("Fail"); textcolor(7); addstr(" because there isn't any network code\n"); refresh;
textcolor(15); addch(ACS_DIAMOND); textcolor(7); addstr(" Resetting Variables ... "); refresh;
for ($i = 1; $i <= 40; $i++) { $mess[$i] = ""; }
$wherescr = 2;
$scrdir = "";
$messwaiting = 0;
$pageswaiting = 22;
$pingtime = 0; $ircconnections = 0;
$leftwindow = 1; $lusers = 0; newWindowInit($thiswin, 1);
$cpagess = ""; $ltime = ""; $ldate = ""; $ppp = ""; $getmes = ""; $s = ""; $timeto_update = 0;
textcolor(10); addstr("Complete\n"); refresh;
textcolor(15); addch(ACS_DIAMOND); textcolor(7); addstr(" Parsing Command-line Parameters ... "); refresh;
if (index("@ARGV", "/NOF") < 0) { $nofade = ""; } else { $nofade = 1; }
if (index("@ARGV", "/NOSO") < 0) { $soundoff = ""; } else { $soundoff = 1; }
if (index("@ARGV", "/NOSC") < 0) { $scrolloff = ""; } else { $scrolloff = 1; }
if (index("@ARGV", "DEBUG") < 0) { $debug = ""; } else { $debug = 1; }
textcolor(10); addstr("Complete\n"); refresh;
textcolor(15); addch(ACS_DIAMOND); textcolor(7); addstr(" Initializing Network Packets ... "); refresh;
textcolor(12); addstr("Fail"); textcolor(7); addstr(" -- see above\n"); refresh;
textcolor(15); addch(ACS_DIAMOND); textcolor(7); addstr(" Searching for other users\n"); refresh;
#textcolor(12); addstr("Fail"); textcolor(7); addstr(" -- see above\n"); refresh;
#textcolor(11); addch(
$amserver = 1;

sleep 1;	# This is only temporary, obviously

if ($amserver)
{
  textcolor(15); addch(ACS_DIAMOND); textcolor(7); addstr(" No other users present.\n"); refresh;
}
textcolor(15); addch(ACS_DIAMOND); textcolor(7); addstr(" " . Lang(4));

$progname = "`2A`0ndy`2C`0hat `6v`\$3`6.`\$0`\@b";
$onlinenum = int($carrnum);
if ($my{'name'} eq "") { $my{'name'} = "USER$carrnum"; }
# $tmpusr{'name'} = $my{'name'};
# if (finduser(@tmpusr, 1) > 0)
# {
#   while(findusr(@tmpusr, 1) > 0)
#   {
#     $k = int(rand(9999)) + 1;
#     $tmpusr{'name'} = "USER" . strpadd("", 4 - length($k), "0") . $k;
#   }
#   $my{'name'} = $tmpusr{'name'};
# }

$my{'number'} = strpadd("", 3 - length($onlinenum), "0") . $onlinenum;

$tnum = int($onlinenum);

while ($tnum > 14) {
  $tnum = $tnum - 14;
}

clear;
DrawMainScreen();
textcolor($colour{'topline'});
addstr(0, 0, " You are user number ");
textcolor(15);
addstr(wherey(), wherex(), $onlinenum);
textcolor($colour{'topline'});
addstr(wherey(), wherex(), " and your alias is ");
textcolor($tnum);
addstr(wherey(), wherex(), $my{'name'});
textcolor($colour{'topline'});
addstr(wherey(), wherex(), ".  ");
addstr(SPACEs($maxx - wherex()));

refresh;

if (index(uc("@ARGV"), "/NOI") < 0)
{
  DrawLogo($my{'name'});
  textcolor(7);
  ScrollText("Press Any Key to actually start chatting away, not just any key tho, because this key will appear in your buffer.  So make it a good one!  ", $maxx - 15, $maxy - 2, 14, 0.1);
  gotoxy($maxx - 15, $maxy - 2);  LordWrite($progname);
  for ($j = 1; $j <= 8; $j++)
  {
    addstr($j + 3, 2 + $loceoff, SPACEs(57));
  }
  addstr(13, 2 + $loceoff, SPACEs(57));

  refresh();
}

if ($window[$thiswin]->{topic} ne "")
{
  ReTitle("[" . $my{'room'} . "] " . $window[$thiswin]->{'topic'});
}
else
{
  ReTitle("[" . $my{'room'} . "]");
}

refresh();

textcolor($colour{'topline'});
addstr(0, 0, " AndyChat v3.00 Build " .  $Build . " -=- (c) Copyright 1997-2000 by Andypoo's Software!");
addstr(SPACEs($maxx - wherex()));

gotoxy(1, $maxy - 2);
refresh();

%tmpusr = %my;
$tmpusr{'name'} = "`" . colline($tnum) . $my{'name'};

# AddUser(@tmpusr, $tmpusr{'number'});

while ((uc($ppp) ne "X NOW") && ($getmes ne "allquit"))
{
  if ($locas ne "")		# Check server commands from self --> self
  {
    if ($messwaiting < 20)
    {
      $messwaiting++;
#      UpdateGame(5);
      $mess[$messwaiting] = $locas;
    }
    else
    {
      for ($t = 1; $t <= 19; $t++)
      {
        $mess[$t] = $mess[$t + 1];
      }
      $mess[20] = $locas;
    }
    $locas = "";
    gotoxy(1, $maxy - 2);
  }

  if (keypressed())
  {
    $ppp = ""; $astr = ""; $bktype = 11;
    $astr = kbuf();
    if ($astr eq chr(27))
    {
#      addstr("." . ord($astr) . ".");
      if ((keypressed()) && ($kbuff eq "["))
      {
        $astr = kbuf();
#        addstr("." . ord($astr) . ".");
        if (keypressed())
        {
          $astr = kbuf();
          if (ord($astr) eq 65) # Up
          {
            $astr = $backtype[10]; $bktype = 10;
          }
          elsif (ord($astr) eq 66) # Down
          {
            $astr = "";
          }
          elsif (ord($astr) eq 67) # Right
          {
            $astr = "";
          }
          elsif (ord($astr) eq 68) # Left
          {
            $astr = "";
          }
          elsif (ord($astr) eq 49)
          {
            if (keypressed())
            {
              $astr = kbuf();
              if (ord($astr) eq 126) # Home
              {
              }
              else
              {
              }
            }
            else
            {
              # We've lost it :)
            }
            $astr = "";
          }
          elsif (ord($astr) eq 50) # Urk
          {
            if (keypressed())
            {
              $astr = kbuf();
              if (ord($astr) eq 126) # Insert
              {
              }
              else
              {
              }
            }
            else
            {
              # We've lost it :)
            }
            $astr = "";
          }
          elsif (ord($astr) eq 51) # Urk
          {
            if (keypressed())
            {
              $astr = kbuf();
              if (ord($astr) eq 126) # Delete
              {
              }
              else
              {
              }
            }
            else
            {
              # We've lost it :)
            }
            $astr = "";
          }
          elsif (ord($astr) eq 52) # Urk
          {
            if (keypressed())
            {
              $astr = kbuf();
              if (ord($astr) eq 126) # End
              {
              }
              else
              {
              }
            }
            else
            {
              # We've lost it :)
            }
            $astr = "";
          }
          elsif (ord($astr) eq 53) # Urk
          {
            if (keypressed())
            {
              $astr = kbuf();
              if (ord($astr) eq 126) # PgUp
              {
              }
              else
              {
              }
            }
            else
            {
              # We've lost it :)
            }
            $astr = "";
          }
          elsif (ord($astr) eq 54) # Urk
          {
            if (keypressed())
            {
              $astr = kbuf();
              if (ord($astr) eq 126) # PgDn
              {
              }
              else
              {
              }
            }
            else
            {
              # We've lost it :)
            }
            $astr = "";
          }
          else
          {
#            addstr("." . ord($astr) . ".");
            $astr = "";
          }
#          LordWrite("`0Escape, [, something pressed...`7");
        }
        else
        {
#          LordWrite("`\@Hmmm, we have a problem...`7");
        }
      }
      else
      {
#        LordWrite("`0Escape and nothing more important...`7");
      }
    }
    elsif (ord($astr) eq 127)
    {
      $astr = "";
    }
#    elsif (ord($astr) > 127)
#    {
#      $astr = ord($astr);
#    }
    if (ord($astr) > 31)
    {
      gotoxy(1, $maxy - 2); textcolor(10); addstr($my{'name'} . ": "); refresh;
      textcolor($colour{'typemsg'}); $astr = GetLLine($astr, $maxx - 20 - length($my{'name'}), 240);
      gotoxy(1, $maxy - 2); textcolor(7); addstr(strpadd("", $maxx - 18, " ")); refresh;
#      addstr("." . ord($astr) . ".");			# Hack
#      if ($astr eq "x") { $ppp = "X NOW"; }		# Hack
    }
    else
    {
      $astr = "";
    }
    afterinp:
    $afterinpu = "";
    $strout = $astr;
    if ($strout ne "")
    {
      for ($i = 1; $i <= 9; $i++)
      {
        $backtype[$i] = $backtype[$i + 1];
      }
      $backtype[10] = $strout;
    }
    $exitnut = 1;
    $bsl = length($strout . $my{'name'}) + 2;
    $ppp = rtrim(ltrim($strout));
    if (uc($ppp) eq "X") { $ppp = "X NOW"; }
    if (substr($ppp, 0, 1) eq "/")
    {
      $s = "";
      SaveSpace(); $ppp = "";
      if ($cheatdeath) { goto fakenum; }
      if ($afterinpu) { goto afterinp; }
    }
    else
    {
      $ppp = Strrrp($ppp);
      if ($ppp ne "")
      {
        $s = "@@" . $my{'room'} . "`" . colline($tnum) . $my{'name'} . ": `7" . $ppp;
#        if (uc($ppp) ne "X NOW") { AddLine($ppp, "`" . colline($tnum) . $my{'name'} . ": `7"); }
      }
      else
      {
        $s = "";
      }
    }
  }
  DoIdleLoop;
  if (($s eq "") && (time() - $timeto_update > 30))
  {
    $s = "##000who";
    $timeto_update = time();
  }
  if (($s ne "") && (uc($ppp) ne "X NOW"))
  {
    if ($window[$thiswin]->{protocol} eq 1)
    {
      # SendIPX($s, $ipxsocket);
      AddLine($ppp, "`" . colline($tnum) . $my{'name'} . ": `7");
    }
    elsif (($window[$thiswin]->{protocol} eq 2) && ($ppp ne ""))
    {
      irc__privmsg($window[$thiswin]->{control}, $window[$thiswin]->{channel}, $ppp);
      AddLine($ppp, "`#<`7" . $my{'name'} . "`#> `7");
    }
    if ($debug) { AddLine("OUT: " . $s); }
    $s = ""; $ppp = "";
  }
  if (($locas ne "") && (index(uc($locas), "X NOW") < 0))
  {
    if ($messwaiting < 20)
    {
      $messwaiting++;
#      UpdateGame(5);
      $mess[$messwaiting] = $locas;
    }
    else
    {
      for ($t = 1; $t <= 19; $t++)
      {
        $mess[$t] = $mess[$t + 1];
      }
      $mess[20] = $locas;
    }
    $locas = "";
    gotoxy(1, $maxy - 2);
  }
  # EatWaiting();
  refresh();
}

if ($logging)
{
  print logfile "\nLogfile closed on " . qbDATE() . " @ " . qbTIME() . "\n";
  close(logfile);
}

if (not $nolang)
{
  close(langfile);
}

# if ((MSCDEXLoaded) && (DrvBusy) && ($cdstoponexit))
# {
#   PauseAudio;
# }

endwin();

#sleep 60;
